package Stage1;

import java.util.ArrayList;
/**
 * This class characterizes each line, identifies its name
 * and an array of stations through which the line passes
 */
public class Line {
    public String lineName;
    private ArrayList<Station> stations;

    /**
     * Line Class Constructor needs the name of the line
     * as parameter.
     * @param line (String): name of line.
     */
    public Line(String line){
        lineName = line;
        stations = new ArrayList<Station>();
    }

    /**
     * Adds the given Station to the Line object.
     * @param station (Station): The station through which 
     * the line passes.
     */
    public void addStations(Station station){
        stations.add(station);
    }

    /**
     * Void method, prints every station through which the 
     * line passes
     */
    public void printStations(){
        System.out.println("--- Linea " + lineName + " ---");
        for(Station station : stations){
            System.out.println(station.stationName);
            if(station.getLine().size() > 1){
                for(int i = 0; i < station.getLine().size(); i++){
                    if(!station.getLine().get(i).lineName.equals(this.lineName)){
                        System.out.print("\t -> Combinacion con linea " + station.getLine().get(i).lineName);
                    }
                }
                System.out.println("");
            }
            else{
                System.out.println("");
            }
        }
    }
}