package Stage2;

import java.io.File;
import java.util.Scanner;
import java.util.ArrayList;

public class DataReader {
    public DataReader(String arg){
        try {
            scanner = new Scanner(new File(arg));
            stations = new ArrayList<Station>();
            lines = new ArrayList<Line>();
        } catch (Exception e) {
            System.out.println("No input handed");
        }
    }

    public void readData(){
        Line tmpLine = new Line("");
        Station tmpStation = new Station("",tmpLine,0,0);
        while (scanner.hasNextLine()) {
            String[] tokens = scanner.nextLine().split(",");

            // Line creation
            boolean newLine = true;
            if(!lines.isEmpty()){
                for(Line line : lines){
                    if(tokens[0].equals(line.lineName)){newLine = false; break;}
                }
            }
            if(newLine){
                tmpLine = new Line(tokens[0]);
                lines.add(tmpLine);
            }

            // Station creation
            boolean newStation = true;
            if(!stations.isEmpty()){
                for(Station station : stations){
                    if(tokens[1].equals(station.stationName)){
                        station.addLine(tmpLine);
                        tmpStation = station;
                        newStation = false;
                    }
                }
            }
            if(newStation){
                tmpStation = new Station(tokens[1], tmpLine,Integer.parseInt(tokens[2]),Integer.parseInt(tokens[3])); 
                stations.add(tmpStation);
            }

            // Station Asignation
            for(Line line : lines){
                if(tokens[0].equals(line.lineName)){
                    line.addStations(tmpStation);
                }
            }
        }
        scanner.close();
    }

    public ArrayList<Line> getLines(){
        return lines;
    }
    
    private Scanner scanner;
    private ArrayList<Station> stations;
    private ArrayList<Line> lines;
}