package Stage2;

import java.util.ArrayList;
import java.util.Random;

import javafx.scene.Group;
import javafx.scene.shape.*;
import javafx.scene.shape.Line;
import javafx.scene.paint.*;

public class LineView extends Group {
    
    private Color color;

    private Group lineGroup;
    private Group circleGroup;

    public LineView(){
        Random rand = new Random();
        color = Color.rgb(rand.nextInt(256),rand.nextInt(256),rand.nextInt(256));
        lineGroup = new Group();
        circleGroup = new Group();
    }

    public void getView(ArrayList<Station> stations){
        this.getChildren().add(drawLines(stations));
        this.getChildren().add(drawStations(stations));

        this.getChildren().add(new Train(stations));
        this.getChildren().add(new Train(stations,stations.size()-1,-1));
    }

    public Group drawLines(ArrayList<Station> stations){
        int index = 0;
        // Draw Lines
        for(Station station : stations){
            if(index < stations.size() - 1){
                Line line = new Line(station.getX(),station.getY(),stations.get(index+1).getX(),stations.get(index+1).getY());
                line.setStrokeWidth(8); line.setStroke(color);;
                lineGroup.getChildren().add(line);
            }
            index++;
        }
        return lineGroup;
    }

    public Group drawStations(ArrayList<Station> stations){
        // Draw Circles
        for(Station station : stations){            
            Group circles = new Group(new Circle(station.getX(),station.getY(), 14, Color.BLACK),
                                        new Circle(station.getX(),station.getY(), 8, Color.WHITE));

            circles.setOnMouseEntered(e->{
                circles.setScaleX(1.2); circles.setScaleY(1.2);
            });
            circles.setOnMouseExited(e->{
                circles.setScaleX(1);   circles.setScaleY(1);
            });
            
            circleGroup.getChildren().add(circles);
        }
        return circleGroup;
    }
}