package Stage3;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.image.Image;

public class Stage3 extends Application{
    
    @Override // Override the start method in the Application Class
    public void start(Stage primaryStage){
        // Read and sort data
        DataReader dataReader = new DataReader(getParameters().getUnnamed().get(0));
        dataReader.readData();

        // Create the Window
        TabMenu tabs = new TabMenu(dataReader.getLines(),dataReader.getStations());
        tabs.setPrefSize(500, 100);
        tabs.setMinWidth(500);
        Pane mapHolder = new Pane();
        mapHolder.setStyle("-fx-background-color: whitesmoke");
        Pane mapView = new MapView(dataReader.getLines(), dataReader.getStations());
        mapView.setPrefSize(600, 500);
        mapHolder.getChildren().add(mapView);

        // Layout
        BorderPane bp = new BorderPane();
        bp.setLeft(mapHolder);
        bp.setRight(tabs);
        
        // Map area
        Scene scene = new Scene(bp);
        
        // Stage configuration
        primaryStage.setX(100); primaryStage.setY(100);
        primaryStage.getIcons().add(new Image("file:logo.png"));
        primaryStage.setTitle("SmartCityStations");
        primaryStage.setScene(scene);
        primaryStage.show();
        
    }

    public static void main(String[] args) {
        launch(args);
    }
}
