package Stage4;

import java.util.ArrayList;

public class Line {
    public String lineName;
    private ArrayList<Station> stations;
    private ArrayList<Train> trains;
    private LineView lineView;


    public Line(String line){
        lineName = line;
        stations = new ArrayList<Station>();
        trains = new ArrayList<Train>();
        lineView = new LineView();
    }

    public void addStations(Station station){
        stations.add(station);
    }

    public String printStations(){
        String data;
        data = "--- Línea " + lineName + " ---\n\n";
        for(Station station : stations){
            data = data + station.stationName + "\n";
            if(station.getLine().size() > 1){
                for(int i = 0; i < station.getLine().size(); i++){
                    if(!station.getLine().get(i).lineName.equals(this.lineName)){
                        data = data + "->\t Combinación con línea " + station.getLine().get(i).lineName;
                    }
                }
                data = data + "\n";
            }
            data = data + "\n";
        }
        data = data + "--- --- --- ---\n\n";
        return data;
    }

    public ArrayList<Station> getStations(){
        return stations;
    }

    public ArrayList<Train> getTrains(){
        return trains;
    }
    
    public LineView getView(){
        lineView.getView(stations);
        return lineView;
    }

    public void addTrain(int startingStation, int direction){
        Train newTrain = new Train(this, startingStation, direction);
        trains.add(newTrain);
        lineView.getChildren().add(newTrain);
    }
}