package Stage4;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.image.Image;

public class Stage4 extends Application{
    @Override // Override the start method in the Application Class
    public void start(Stage primaryStage){
        // Read and sort data
        DataReader dataReader = new DataReader(getParameters().getUnnamed().get(0));
        dataReader.readData();

        // Create the Window
        TabMenu tabs = new TabMenu(dataReader.getLines(),dataReader.getStations());
        BorderPane mapView = new MapView(dataReader.getLines(), dataReader.getStations());
        mapView.setPrefSize(500, 500);

        // Layout
        BorderPane bp = new BorderPane();
        bp.setLeft(mapView);
        bp.setRight(tabs);
        bp.setStyle("-fx-background-color: antiquewhite;");
        
        // Map area
        Scene scene = new Scene(bp);
        
        // Stage configuration
        //primaryStage.setX(100); primaryStage.setY(100);
        primaryStage.getIcons().add(new Image("file:src/logo.png"));
        primaryStage.setTitle("SmartCityStations");
        primaryStage.setScene(scene);
        primaryStage.show();
        
    }

    public static void main(String[] args) {
        launch(args);
    }
}
