package Stage4;

import javafx.scene.Group;
import javafx.scene.control.Label;
import javafx.scene.shape.Circle;
import javafx.scene.paint.Color;
import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import javafx.util.Duration;

public class StationView extends Group{
    private Group circleGroup;
    private Label stationName;
    private Timeline animation;

    public StationView(){
        circleGroup = new Group();
        stationName = new Label();
        stationName.setStyle("-fx-font: sans-serif");
        stationName.setStyle("-fx-font-weight: bold");
        
    }
    
    public void getView(Station station){
        // Draw Circles
        Group circles = new Group(new Circle(station.getX(),station.getY(), 14, Color.BLACK),
                                    new Circle(station.getX(),station.getY(), 8, Color.WHITE));
        
        circleGroup.getChildren().add(circles);
        this.getChildren().add(circles);
        
        circles.setOnMouseClicked(e->{
            TabMenu.changeStationInfo(station,true);
        });

        circles.setOnMouseEntered(e->{
            circles.setScaleX(1.2); circles.setScaleY(1.2);
            stationName.setText(station.stationName);
            stationName.setTranslateX(station.getX() - station.stationName.length()*4);
            stationName.setTranslateY(station.getY() - 33);
            this.getChildren().add(stationName);
        });

        circles.setOnMouseExited(e->{
            circles.setScaleX(1);   circles.setScaleY(1);
            this.getChildren().remove(stationName);
        });

        animation = new Timeline(new KeyFrame(Duration.millis(1000), e->TabMenu.changeStationInfo(station,false)));
        animation.setCycleCount(Timeline.INDEFINITE);
        animation.play();
    
    }
}