package Stage4;

import java.util.ArrayList;
//import javafx.collections.*;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.*;
//import javafx.scene.layout.Pane;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;
//import javafx.geometry.Insets;

public class TabMenu extends TabPane{
    // FIELDS
    private static int winWidth = 250;
    private static BorderPane stationPane;
    private static BorderPane trainPane;
    private static BorderPane infoBP;
    private static GridPane routePane;
    private static Train train;
    private static Station station;

    public TabMenu(ArrayList<Line> lines,ArrayList<Station> stations){
        Tab stationTab = new Tab();
        stationPane = new BorderPane();
        stationTab.setText("Estación");
        stationTab.setClosable(false);
        stationTab.setContent(stationPane);
        
        Tab trainTab = new Tab();
        trainPane = new BorderPane();
        trainTab.setText("Tren");
        trainTab.setClosable(false);
        trainTab.setContent(trainPane);
        
        
        Tab infoTab = new Tab();
        infoBP = createInfoTab(lines);
        infoTab.setText("Información");
        infoTab.setClosable(false);
        infoTab.setContent(infoBP);

        Tab routeTab = new Tab();
        routeTab.setText("Buscador de Rutas");
        routeTab.setClosable(false);
        routePane = new GridPane();
        try {
            routePane = FXMLLoader.<GridPane>load(getClass().getResource("grid.fxml"));
        } catch (Exception e) {
            System.out.println("wrong.");
        }
        //bpGrid = new BorderPane(createRouteTab(stations));
        
        routeTab.setContent(routePane);
        
        this.getTabs().addAll(infoTab, stationTab, trainTab, routeTab);
        // this.setMaxWidth(500);      this.setMinWidth(winWidth);
        // this.setPrefSize(350, 100);
        this.setMinWidth(winWidth);
        this.setPrefWidth(600);
        this.setStyle("-fx-background-color: gainsboro; -fx-border-color:dimgray");
        
    }

    public static void changeStationInfo(Station _station, boolean newStation){
        // If it is a different station
        if(newStation){
            station = _station;
        }

        if(station == null){
            return;
        }

        stationPane.getChildren().clear();
        String dataS;
        TextArea stationText = new TextArea();
        // stationText.setMaxWidth(winWidth);  
        // stationText.setMaxHeight(450); stationText.setMinHeight(350);
        // stationText.setPrefSize(winWidth, 400);
        stationText.setMaxWidth(400);     stationText.setMaxHeight(400);
        stationText.setWrapText(true);
        
        dataS = "Estación : " + station.stationName + "\n";
        
        ArrayList<Line> lines = station.getLine();

        for (Line line : lines) {
            dataS = dataS + "\n---Línea : " + line.lineName + "---\n";
            String firstStation = line.getStations().get(0).stationName;
            String lastStation = line.getStations().get(line.getStations().size()-1).stationName;

            int stationIndex = line.getStations().indexOf(station);
            double bestTime = Double.POSITIVE_INFINITY;
            
            //First Station
            if(stationIndex == 0){
                bestTime = bestTime(line.getTrains(),stationIndex, -1);
                if(Double.isInfinite(bestTime)){
                    dataS = dataS + "No hay trenes con destino " + lastStation + "\n";
                }
                else{
                    bestTime -= AppTime.getCurrentTime();
                    dataS = dataS + "Siguiente tren con destino " + lastStation + "\n";
                    dataS = dataS + "En " + (int)bestTime + "[s]" + "\n";
                }
            }
            //Last Station
            else if (stationIndex == line.getStations().size()-1){
                bestTime = bestTime(line.getTrains(),stationIndex, 1);
                if(Double.isInfinite(bestTime)){
                    dataS = dataS + "No hay trenes con destino " + firstStation + "\n";
                }
                else{
                    bestTime -= AppTime.getCurrentTime();
                    dataS = dataS + "Siguiente tren con destino " + firstStation + "\n";
                    dataS = dataS + "En " + (int)bestTime + "[s]" + "\n";
                }
            }
            //Any other station
            else{
                bestTime = bestTime(line.getTrains(),stationIndex, 1);
                if(Double.isInfinite(bestTime)){
                    dataS = dataS + "No hay trenes con destino " + lastStation + "\n\n";
                }
                else{
                    bestTime -= AppTime.getCurrentTime();
                    dataS = dataS + "Siguiente tren con destino " + lastStation + "\n";
                    dataS = dataS + "En " + (int)bestTime + "[s]" + "\n";
                }

                bestTime = bestTime(line.getTrains(),stationIndex, -1);
                if(Double.isInfinite(bestTime)){
                    dataS = dataS + "No hay trenes con destino " + firstStation + "\n";
                }
                else{
                    bestTime -= AppTime.getCurrentTime();
                    dataS = dataS + "Siguiente tren con destino " + firstStation + "\n";
                    dataS = dataS + "En " + (int)bestTime + "[s]" + "\n";
                }
            }
        }    
        // Pane top = new Pane();
        // top.setMaxHeight(25);top.setMinHeight(25);top.setPrefHeight(25);
        // Pane bottom = new Pane();
        // bottom.setMaxHeight(25);bottom.setMinHeight(25);bottom.setPrefHeight(25);
        // stationPane.setTop(bottom);
        // stationPane.setTop(top);
        stationText.setText(dataS);
        stationPane.setCenter(stationText);
    }

    /**
     * 
     */
    private static double bestTime(ArrayList<Train> trains,int stationIndex, int direction){
        double bestTime = Double.POSITIVE_INFINITY;
        double time;
        for (Train train : trains) {
            time = train.time2Destination(stationIndex,direction);
            bestTime = (time < bestTime) ? time : bestTime;
        }
        return bestTime;
    }
    
    /**
     * 
     * @param _train
     * @param newTrain
     */
    public static void changeTrainInfo(Train _train, boolean newTrain){
        // If it is a different train
        if (newTrain){
            train = _train;
        }

        if(train == null){
            return;
        }
        
        trainPane.getChildren().clear();
        String dataT = "";
        TextArea trainText = new TextArea();
        // trainText.setMaxWidth(winWidth);
        // trainText.setMaxHeight(450);trainText.setMinHeight(350);
        // trainText.setPrefSize(winWidth, 400);
        trainText.setMaxWidth(400);    trainText.setMaxHeight(400);
        trainText.setWrapText(true);
        
        if(train.getDirection() == 1){
            String finalStation = train.getLine().getStations().get(train.getLine().getStations().size()-1).stationName;
            dataT = dataT + "Tren de la Linea " + train.getLine().lineName + ", con destino " + finalStation + "\n";
        }
        else{
            String firstStation = train.getLine().getStations().get(0).stationName;
            dataT = dataT + "Tren de la Linea " + train.getLine().lineName + ", con destino " + firstStation + "\n";
        }
        dataT = dataT + "Siguiente estacion : " + train.getStation().stationName + "\n";
        int time = (int)train.time2Destination()- (int)AppTime.getCurrentTime();
        dataT = dataT + "Tren con " + train.getPassengers() + " pasajeros a bordo" + "\n";
        dataT = dataT + "El tren llegara en : " + time + "[s]" + "\n";
        
        // Pane top = new Pane();
        // top.setMaxHeight(25);top.setMinHeight(25);top.setPrefHeight(25);
        // Pane bottom = new Pane();
        // bottom.setMaxHeight(25);bottom.setMinHeight(25);bottom.setPrefHeight(25);
        // trainPane.setTop(bottom);
        // trainPane.setTop(top);
        trainText.setText(dataT);
        trainPane.setCenter(trainText);
    }   
    /**
     * Sets the information tab.
     */ 
    public static BorderPane createInfoTab(ArrayList<Line> lines){
        infoBP =  new BorderPane();
        MenuBar menuBar =  new MenuBar();
        Menu mLine = new Menu("Líneas");
        MenuItem item;
        String lineName;
        TextArea infoT = new TextArea();
        infoT.setText("\n\n\nGracias por usar nuestro servicio");
        // infoT.setMaxWidth(winWidth);
        // infoT.setMaxHeight(450); infoT.setMinHeight(350);
        // infoT.setPrefSize(winWidth, 400);
        infoT.setMaxWidth(400);     infoT.setMaxHeight(400);
        infoT.setWrapText(true);

        // Actions
        for(Line i:lines){
            lineName = i.lineName;
            item = new MenuItem("--- Línea " + lineName + " ---");
            mLine.getItems().add(item);
            item.setOnAction(e -> {
                infoT.setText(i.printStations());
            });
        }
        item = new MenuItem("--- Info ---");
        mLine.getItems().add(item);
        item.setOnAction(e -> {
            infoT.setText("\n\n\nGracias por usar nuestro servicio");
        });
        menuBar.getMenus().addAll(mLine);

        // Pane bottom = new Pane();
        // bottom.setMaxHeight(25);bottom.setMinHeight(25);bottom.setPrefHeight(25);
        // infoBP.setTop(bottom);
        // menuBar.setMaxHeight(25);menuBar.setMinHeight(25);menuBar.setPrefHeight(25);
        infoBP.setTop(menuBar);
        infoBP.setCenter(infoT);

        return infoBP;
    }

       
    /**
     * Sets the information tab.
     */ 
    // public GridPane createRouteTab(ArrayList<Station> stations){
    //     // Set the grid
    //     gPane.setStyle("-fx-background-color: whitesmoke;");
    //     gPane.setPrefSize(winWidth,400);
    //     gPane.setMinWidth(winWidth);
    //     gPane.setVgap(10);      gPane.setHgap(10);
    //     gPane.setPadding(new Insets(25, 15, 25, 15)); //top,right,bottom,left
    //     gPane.setGridLinesVisible(false);
    //     ArrayList<String> list = new ArrayList<String>();

    //     // Se agregan las estaciones
    //     for(Station i: stations){
    //         list.add(i.stationName);
    //     }
    //     ObservableList<String> options = FXCollections.observableList(list);

    //     final ComboBox origComboBox = new ComboBox(options);
    //     final ComboBox destComboBox = new ComboBox(options);
    //     origComboBox.setValue("-- Origen --");
    //     destComboBox.setValue("-- Destino --");
    //     final Button button = new Button ("Buscar");
    //     final TextArea routeT = new TextArea();
    //     routeT.setText("WORK IN PROGRESS... \n\n\n" + WORKINPROGRESS());
    //     routeT.setPrefSize(winWidth, winWidth);
    //     routeT.setMinHeight(winWidth);       routeT.setMinWidth(winWidth);
    //     // orden - node, col, row, spanC, spanR
    //     gPane.add(new Label("--- Buscar Ruta ---"), 2, 0, 3, 1);
    //     gPane.add(new Label("Origen: "), 1, 3);
    //     gPane.add(origComboBox, 1, 4, 4, 2);
    //     gPane.add(new Label("Destino: "), 1, 6);
    //     gPane.add(destComboBox, 1, 7, 4, 2);
    //     gPane.add(button, 3, 9);
    //     gPane.add(routeT, 0, 10, 5, 5);
    //     return gPane;
    // }


    private String WORKINPROGRESS(){
        String data;
        data =  "                                               ///////////////////////\n";
        data += "                                            ,/             /          /\n";
        data += "                                           //////*        /    /////  /* \n";
        data += "                                         ,/      /         /   ///////  //   \n";
        data += "                                        //       /         /     //(      /. \n";
        data += "                                      ./        ,/*       ,//     /        //\n";
        data += "                                     /(       (/////(   ,/////(  /           /\n";
        data += "             //////////////////////   //       /////     (////   /          /, \n";
        data += "           .///////////.  */////////.  ,/                         /       // \n";
        data += "          ///////////*      //////////   /*                    //,       /*\n";
        data += "         /////////////     .///////////.  /(  (//////////////(/        ,/ \n";
        data += "       ///////////// .///////////////////   //                        //\n";
        data += "      ///////////. ,*/////   .///////////    /(                     ,*\n";
        data += "    ///////////  ///////                .///   //////////////////////\n";
        data += "               //////////     ///////////////\n";
        data += "    *//////////////////////////////////////,   //////////////////////, \n";
        data += "      *///////////      /////////////////*   /*//////////////////////// \n";
        data += "       *//////////                                 ///////////.   //////. \n";
        data += "         //////////,  ,////////////////   //////////                ////// \n";
        data += "          ////////////////////////////   /////  ./////////////     ////////  \n";
        data += "            ////////////////////////   /////            ,//////////////////// \n";
        data += "             //////////////////////   //////,     ///////  /////////////      \n";
        data += "                                      /////////////////////             //////*\n";
        data += "                                       //////////////////////////////////////\n";
        data += "                                        ,/////////////////////*\n";
        data += "                                          //////////////////  *//////////*\n";
        data += "                                           *//////////.      ////////////\n";
        data += "                                             *////////,      //////////\n";
        data += "                                              //////////////////////// \n";
        return data;
    }
}